#if defined(VMS) && !defined(MULTINET) && !defined(WIN_TCP)
/*
 * A routine to mimick the ioctl function for UCX.
 * Bjorn S. Nilsson, 25-Nov-1993. Based on an example in the UCX manual.
 * Note. This code was taken out because it crashed OpenVMS 1.5 systems
 * with UCX 3.0. I just hope there are none of these left:-(
 */
#include <stdio.h>
#include <iodef.h>
#include <ucx$inetdef.h>
#include <errno.h>

#define IOC_OUT (int)0x40000000

extern int vaxc$get_sdc(), sys$qiow();

int ioctl (d, request, argp)
int d, request;
char *argp;
{
  int sdc, status;
  unsigned short fun, iosb[4];
  char *p5, *p6;
  struct comm
    {
      int command;
      char *addr;
    } ioctl_comm;
  struct it2
    {
      unsigned short len;
      unsigned short opt;
      struct comm *addr;
    } ioctl_desc;

  if ((sdc = vaxc$get_sdc (d)) == 0)
    {
      errno = EBADF;
      return -1;
    }

  ioctl_desc.opt  = UCX$C_IOCTL;
  ioctl_desc.len  = sizeof(struct comm);
  ioctl_desc.addr = &ioctl_comm;

  if (request & IOC_OUT)
    {
      fun = IO$_SENSEMODE;
      p5 = 0;
      p6 = (char *)&ioctl_desc;
    }
  else
    {
      fun = IO$_SETMODE;
      p5 = (char *)&ioctl_desc;
      p6 = 0;
    }
    
  ioctl_comm.command = request;
  ioctl_comm.addr = argp;

  status = sys$qiow (0, sdc, fun, iosb, 0, 0,
    0, 0, 0, 0, p5, p6);
  if (!(status & 01))
    {
      errno = status;
      return -1;
    }

  if (!(iosb[0] & 01))
    {
      errno = iosb[0];
      return -1;
    }

  return 0;
}
#endif /* VMS, UCX, BSN */
